diff -urNb aodv-uu-0.7.2/igmp.c maodv-umd-0.7.2/igmp.c
--- aodv-uu-0.7.2/igmp.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/igmp.c	Mon Jun 30 16:00:00 2003
@@ -0,0 +1,218 @@
+#ifdef MAODV
+
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *          Jonathan McGee <mcgee@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifdef NS_PORT
+#include "aodv-uu.h"
+#else
+#include <netinet/in.h>
+#include "aodv_socket.h"
+#include "params.h"
+#include "seek_list.h"
+#include "defs.h"
+#include "debug.h"
+#include "multicast_routing_table.h"
+#include "igmp.h"
+#include "icmp.h"
+#include "aodv_rreq.h"
+#include "maodv_mact.h"
+#include "packet_queue.h"
+#endif
+
+static void maodv_join(u_int32_t grp_addr){
+    mrt_table_t *group_rec;
+
+    group_rec=mrt_table_find(grp_addr);
+
+    if(group_rec==NULL){
+        group_rec=mrt_table_insert(grp_addr, 0, 0, 0, 255, 0);
+    }
+   
+    if(group_rec->is_gateway) {
+        /* Gateway code has joined or is in the process of doing so */
+        group_rec->is_member = 1;
+    } else if(!group_rec->is_router){
+        /* no route to group, so let's find one. */
+        rreq_route_discovery(grp_addr, RREQ_JOIN, NULL, 0);
+    }else if(!group_rec->is_member){
+        /* I'm routing, so I just need to reactivate my membership */
+        group_rec->is_member=1;
+    }
+}
+
+static void maodv_leave(u_int32_t grp_addr){
+    mrt_table_t *group_rec;
+
+    group_rec=mrt_table_find(grp_addr);
+    
+    /* don't leave if not in the group */
+    if(group_rec==NULL || !group_rec->is_router)
+        return;
+
+    /* leave group */
+    group_rec->is_member=0;
+
+    /* If gateway mode is enabled, make sure the gateway flag is set */
+    if(this_host.gateway_mode) {
+        group_rec->is_gateway = 1;
+    }
+
+    if(group_rec->is_gateway) {
+        /* Only prune if no up or down stream */
+        if((group_rec->activated_downstream_cnt == 0)
+                && (group_rec->activated_upstream_cnt == 0)) {
+            group_rec->am_leader = 0;
+            group_rec->is_gateway = 0;
+            mrt_table_stop_routing(group_rec);
+
+            /* remove any pending RREQs (or other packets) for this group */
+            seek_list_remove(seek_list_find(grp_addr));
+            packet_queue_drop(grp_addr);
+
+            /* flush all nexthops */
+            mrt_nexthop_remove_all(group_rec);
+        }
+    } else if(group_rec->am_leader){
+        if(group_rec->activated_downstream_cnt>0){
+            /* do have downstreams, so make one new leader */
+            mact_make_downstream_leader(group_rec);
+        }
+        group_rec->am_leader=0;
+        mrt_table_stop_routing(group_rec);
+    }else if(group_rec->activated_downstream_cnt==0){
+        /* no downs, prune self and invalidate route */
+        mrt_nexthop_t *upstream;
+
+        upstream=mrt_table_get_activated_upstream(group_rec);
+        if(upstream != NULL){
+            mact_send(MACT_PRUNE, 1, grp_addr, upstream->addr,1);
+            mrt_nexthop_deactivate(group_rec, upstream->addr);
+        }
+        mrt_table_stop_routing(group_rec);
+
+        /* remove any pending RREQs (or other packets) for this group */
+        seek_list_remove(seek_list_find(grp_addr));
+        packet_queue_drop(grp_addr);
+
+        /* flush all nexthops */
+        mrt_nexthop_remove_all(group_rec);
+    }
+    /* otherwise I must keep route valid so I keep routing */
+}
+
+static void maodv_query(IGMP* pkt, int ifindex) {
+    mrt_table_t *tblentry;
+    int n;
+
+    /* Iterate through all the multicast routing entries */
+    for(n = 0; n < MRT_TABLESIZE; n++) {
+        tblentry = mrt_tbl.tbl[n];
+
+        while(tblentry) {
+            igmp_sendreply(tblentry, ifindex);
+            tblentry = tblentry->next;
+        }
+    }
+}
+
+void igmp_process( IGMP *pkt, int ifindex )
+{
+    u_int32_t grp_addr;
+    DEBUG(LOG_DEBUG, 0, "IGMP packet out. Dropped.");
+
+    grp_addr=ntohl(pkt->igmp_group.s_addr);
+
+    switch( pkt->igmp_type ) {
+        case IGMP_V1_MEMBERSHIP_REPORT:
+        case IGMP_V2_MEMBERSHIP_REPORT:
+            DEBUG(LOG_DEBUG, 0, "IGMP_REPORT");
+
+            /* may not do anything if we already have a valid route. */
+            maodv_join( grp_addr ); 
+
+            break;
+        case IGMP_V2_LEAVE_GROUP:
+            DEBUG(LOG_DEBUG, 0, "IGMP_LEAVE");
+
+            /* it may not actually prune, but at least un-member me. */
+            maodv_leave( grp_addr ); 
+
+            break;
+        case IGMP_MEMBERSHIP_QUERY:
+            DEBUG(LOG_DEBUG, 0, "IGMP_QUERY");
+
+            /* Terrestrial multicast router is asking for list of groups */
+            maodv_query( pkt, ifindex );
+
+            break;
+        default:
+            DEBUG(LOG_DEBUG, 0, "IGMP_UNKNOWN [0x%x]", pkt->igmp_type );
+            break;
+    }
+}
+
+void igmp_sendreply(mrt_table_t* mrt, int ifindex) {
+    char szBuffer[sizeof(struct iphdr) + sizeof(struct igmphdr)];
+    struct iphdr* ip = (struct iphdr*)szBuffer;
+    struct igmphdr* igmp = (struct igmphdr*)(szBuffer + sizeof(struct iphdr));
+    int injectfd = DEV_IFINDEX(ifindex).injectfd, err;
+
+    if(!mrt->nexthops || !mrt->is_router) {
+        /* Nobody listening, so don't send */
+        return;
+    }
+
+    if(injectfd != -1) {
+        ip->version = IPVERSION;
+        ip->ihl = sizeof(struct iphdr) >> 2;
+        ip->tos = 0;
+        ip->tot_len = htons(sizeof(szBuffer));
+        ip->id = 1;
+        ip->frag_off = 0;
+        ip->ttl = 1;
+        ip->protocol = IPPROTO_IGMP;
+        ip->saddr = htonl(mrt->nexthops->addr);
+        ip->daddr = htonl(mrt->grp_addr);
+        ip->check = 0;
+        ip->check = cksum((unsigned short*)ip, sizeof(struct iphdr));
+        igmp->type = IGMP_V1_MEMBERSHIP_REPORT;
+        igmp->code = 0;
+        igmp->group = ip->daddr;
+        igmp->csum = 0;
+        igmp->csum = cksum((unsigned short*)igmp, sizeof(struct igmphdr));
+
+        DEBUG(LOG_DEBUG, 0, "Injecting IGMP REPORT for %s from %s on %s",
+            ip_to_str(ntohl(ip->daddr)), ip_to_str(ntohl(ip->saddr)),
+            DEV_IFINDEX(ifindex).ifname);
+        err = write(injectfd, szBuffer, sizeof(szBuffer));
+        if(err < sizeof(szBuffer)) {
+            perror("write");
+        }
+    }
+}
+
+#endif /* MAODV */
diff -urNb aodv-uu-0.7.2/igmp.h maodv-umd-0.7.2/igmp.h
--- aodv-uu-0.7.2/igmp.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/igmp.h	Wed Jun 25 17:46:09 2003
@@ -0,0 +1,47 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *          Jonathan McGee <mcgee@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifndef IGMP_H
+#define IGMP_H
+
+#ifndef NS_NO_GLOBALS
+
+#include "defs.h"
+#include "multicast_routing_table.h"
+#include <netinet/igmp.h>
+
+#define IGMP    struct igmp
+
+#endif				/* NS_NO_GLOBALS */
+
+#ifndef NS_NO_DECLARATIONS
+
+void igmp_process( IGMP * buff, int ifindex );
+void igmp_sendreply( mrt_table_t * mrt, int ifindex );
+
+#endif				/* NS_NO_DECLARATIONS */
+
+#endif				/* IGMP_H */
diff -urNb aodv-uu-0.7.2/k_mroute.c maodv-umd-0.7.2/k_mroute.c
--- aodv-uu-0.7.2/k_mroute.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/k_mroute.c	Thu Jul 17 18:03:42 2003
@@ -0,0 +1,239 @@
+#ifdef MAODV
+
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#include "k_mroute.h"
+#include <stdio.h>    /* perror */
+#include <unistd.h>
+#include <sys/socket.h>
+#include <linux/in.h>
+#include <linux/mroute.h>
+#include <string.h>
+
+/* Yanked from debug.h during a battle with the includes. */
+#include <sys/syslog.h>
+void log(int, int, const char *, char *, ...);
+
+int multicast_socket = -1;
+
+/* much of this code was taken from Dinesh's kernel MAODV
+   implementation and cleaned up for user space.
+
+   also, smc_route v.0.92 provided a good user space reference. */
+
+/*
+ *  kernel_mrt_init( )
+ *  Create and initialize the multicast socket for communication with the kernel.
+ */
+int kernel_mrt_init( void )
+{
+    int error;
+    int enable = 1;
+
+    multicast_socket = socket( AF_INET, SOCK_RAW, IPPROTO_IGMP );
+
+    /* error creating socket? */
+    if ( multicast_socket < 0 ) {
+        log(LOG_WARNING, 0, __FUNCTION__,
+            "Failed to create socket.");
+        return -1;
+    }
+
+    error = setsockopt( multicast_socket, IPPROTO_IP, MRT_INIT, 
+        (int *) &enable, sizeof( enable ) );
+    if ( error < 0 ) {
+        log(LOG_WARNING, 0, __FUNCTION__,
+            "Error starting kernel multicast routing.");
+        return -1;
+    }
+
+    log(LOG_DEBUG, 0, __FUNCTION__,
+        "Got the multicast kernel route socket!");
+    
+    return 0;
+}
+
+/*
+ *  kernel_mrt_clean_up( )
+ *  Close the socket and clean up the virtual interfaces.
+ */
+int kernel_mrt_clean_up( void )
+{
+    if(multicast_socket != -1) {
+
+    int error = setsockopt( multicast_socket, IPPROTO_IP, MRT_DONE, 
+        (char *) NULL, 0 );
+    if ( error < 0 ) {
+        log(LOG_WARNING, 0, __FUNCTION__,
+            "Error finishing (MRT_DONE) kernel multicast routing.");
+        return -1;
+    }
+
+    close( multicast_socket );
+
+    log(LOG_DEBUG, 0, __FUNCTION__,
+       "Killed multicast socket!");
+
+    } /* if(multicast_socket != -1) { */
+    return 0;
+}
+
+/*
+ *  kernel_mrt_vif_add( addr, index )
+ *  Adds a virtual interface from ip "addr" as index "index".
+ */
+int kernel_mrt_vif_add( u_int32_t this_ip, int index )
+{
+    if(multicast_socket != -1) {
+
+    struct vifctl vc;
+    int error;
+
+    /* taken from smcroute-0.92 */
+    vc.vifc_vifi = index;
+    vc.vifc_flags = 0;
+    vc.vifc_threshold = 1;
+    vc.vifc_rate_limit = 0;
+                
+    vc.vifc_lcl_addr.s_addr = htonl(this_ip);
+    vc.vifc_rmt_addr.s_addr = INADDR_ANY;
+
+    error = setsockopt( multicast_socket, IPPROTO_IP, MRT_ADD_VIF, 
+        (char *)&vc, sizeof(vc) ); 
+    if ( error < 0 ) {
+        perror("ERROR! " );
+        log(LOG_WARNING, 0, __FUNCTION__,
+            "Error creating virtual interface for kernel multicast routing[%d]." , error );
+        return -1;
+    }
+
+    log(LOG_DEBUG, 0, __FUNCTION__,
+        "Added virtual interface.");
+
+    } /* if(multicast_socket != -1) { */
+   return 0; 
+}
+
+/*
+ *  kernel_mrt_vif_del( addr, index )
+ *  Deletes a virtual interface at  from ip "addr" as index "index".
+ */
+int kernel_mrt_vif_del( u_int32_t this_ip, int index )
+{
+    if(multicast_socket != -1) {
+
+    struct vifctl vc;
+    int error;
+
+    vc.vifc_vifi = (vifi_t) index;
+    vc.vifc_flags = 0;
+    // Is the threshold value 0 or 1??? - Dinesh
+    vc.vifc_threshold = 0;
+    vc.vifc_rate_limit = 0;
+                
+    vc.vifc_lcl_addr.s_addr = htonl(this_ip);
+    vc.vifc_rmt_addr.s_addr = INADDR_ANY;
+
+    error = setsockopt( multicast_socket, IPPROTO_IP, MRT_DEL_VIF, 
+        (char *)&vc, sizeof(vc) ); 
+    if ( error < 0 ) {
+        log(LOG_WARNING, 0, __FUNCTION__,
+            "Error deleting virtual interface for kernel multicast routing.");
+        return -1;
+    }
+
+    } /* if(multicast_socket != -1) { */
+    return 0; 
+}
+
+/*
+ *  kernel_mrt_add_route( source, grp, vif )
+ *  Add a multicast route to the kernel routing cache.
+ */
+int kernel_mrt_add_route( u_int32_t src, u_int32_t grp, int index )
+{
+    if(multicast_socket != -1) {
+
+    struct mfcctl mc;
+    int error;
+
+    mc.mfcc_origin.s_addr = htonl(src);
+    mc.mfcc_mcastgrp.s_addr = htonl(grp);
+    mc.mfcc_parent = (vifi_t) index;
+    memset(mc.mfcc_ttls, 0, sizeof(mc.mfcc_ttls));
+    mc.mfcc_ttls[index] = 2;  /* CHECK: this seems odd... */
+
+    error = setsockopt( multicast_socket, IPPROTO_IP, MRT_ADD_MFC, 
+        (char *) ( &mc ), sizeof( mc ) );
+
+    if ( error < 0 ) {
+        perror( "ERROR " );
+        log(LOG_WARNING, 0, __FUNCTION__,
+            "Error adding route for kernel multicast routing.");
+        return -1;
+    }
+
+    log(LOG_DEBUG, 0, __FUNCTION__,
+        "Added multicast route cache entry.");
+ 
+    } /* if(multicast_socket != -1) { */
+    return 0;
+}
+
+/*
+ *  kernel_mrt_del_route( source, grp, vif )
+ *  Delete a multicast route from the kernel routing cache.
+ */
+int kernel_mrt_del_route( u_int32_t src, u_int32_t grp, int index )
+{
+    if(multicast_socket != -1) {
+
+    struct mfcctl mc;
+    int error;
+
+    /* CHECK: ttls are diff in Dinesh's code... intentional? */
+    mc.mfcc_origin.s_addr = htonl(src);
+    mc.mfcc_mcastgrp.s_addr = htonl(grp);
+    mc.mfcc_parent = (vifi_t) index;
+    mc.mfcc_ttls[index] = 1;
+
+    error = setsockopt( multicast_socket, IPPROTO_IP, MRT_DEL_MFC, 
+        (char *) ( &mc ), sizeof( struct mfcctl ) );
+
+    if ( error < 0 ) {
+        log(LOG_WARNING, 0, __FUNCTION__,
+            "Error deleting route for kernel multicast routing.");
+        return -1;
+    }
+
+    log(LOG_DEBUG, 0, __FUNCTION__,
+        "Removed multicast route cache entry.");
+ 
+    } /* if(multicast_socket != -1) { */
+    return 0;
+}
+
+#endif /* MAODV */
diff -urNb aodv-uu-0.7.2/k_mroute.h maodv-umd-0.7.2/k_mroute.h
--- aodv-uu-0.7.2/k_mroute.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/k_mroute.h	Wed Jun 25 17:46:09 2003
@@ -0,0 +1,38 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifndef K_MROUTE_H
+#define K_MROUTE_H
+
+#include <sys/socket.h>
+
+int kernel_mrt_init( void );
+int kernel_mrt_clean_up( void );
+int kernel_mrt_vif_add( u_int32_t this_ip, int index );
+int kernel_mrt_vif_del( u_int32_t this_ip, int index );
+int kernel_mrt_add_route( u_int32_t src, u_int32_t grp, int index );
+int kernel_mrt_del_route( u_int32_t src, u_int32_t grp, int index );
+
+#endif /* K_MROUTE_H */
diff -urNb aodv-uu-0.7.2/kaodv.c maodv-umd-0.7.2/kaodv.c
--- aodv-uu-0.7.2/kaodv.c	Wed Nov  6 08:48:46 2002
+++ maodv-umd-0.7.2/kaodv.c	Fri Dec  5 17:42:32 2003
@@ -117,6 +117,12 @@
     /* Check which hook the packet is on... */
     switch (hooknum) {
     case NF_IP_PRE_ROUTING:
+#ifdef MAODV
+    /* Pass incoming IGMP (since MAODV might have generated it) */
+    if((*skb)->nh.iph->protocol == IPPROTO_IGMP) {
+        break;
+    }
+#endif
 	/* Loop through all AODV enabled interfaces and see if the packet
 	 * is bound to any of them. */
 	for (i = 0; i < nif; i++)
@@ -124,7 +130,12 @@
 		(*skb)->nfmark = 3;
 		goto queue;
 	    }
-	break;
+
+    /* Gateway mode requirement */
+    (*skb)->nfmark = 4;
+    goto queue;
+    goto accept;
+
     case NF_IP_LOCAL_OUT:
 	for (i = 0; i < nif; i++)
 	    if (ifindices[i] == out->ifindex) {
@@ -132,6 +143,7 @@
 		goto queue;
 	    }
 	break;
+
     case NF_IP_POST_ROUTING:
 	/* Re-route all packets before sending on interface. This will
 	   make sure queued packets are routed on a newly installed
diff -urNb aodv-uu-0.7.2/kinject.c maodv-umd-0.7.2/kinject.c
--- aodv-uu-0.7.2/kinject.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/kinject.c	Thu Jul 17 18:03:45 2003
@@ -0,0 +1,280 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Jonathan McGee <mcgee@umd.edu>
+ *
+ *****************************************************************************/
+#include <linux/config.h>
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/notifier.h>
+#include <asm/atomic.h>
+
+#define CONFIG_PROC_FS
+#include <linux/proc_fs.h>
+
+#include <linux/skbuff.h>
+#include <linux/netdevice.h>
+#include <net/ip.h>
+
+/* Root for our network output entries */
+static struct proc_dir_entry *proc_netwrite = NULL;
+
+/* Linked list of installed proc entries */
+struct proc_netwrite_entry {
+    struct proc_netwrite_entry *next;
+    struct proc_dir_entry *entry;
+    const char *devname;
+    struct net_device *dev;
+};
+
+static struct proc_netwrite_entry *proc_netwrite_entries = NULL;
+
+/*
+ * Injecting packets into the IP stack
+ */
+static int proc_netwrite_write(struct file *file, const char *buffer,
+        unsigned long count, void *data) {
+    struct sk_buff *skb = NULL;
+    struct iphdr *ip = (struct iphdr*)buffer;
+    struct net_device *dev = NULL;
+
+    /* Do some sanity checking */
+    if(data == NULL) {
+        printk(KERN_INFO __FILE__ ": %ld bytes written but no output "
+                "device!\n", count);
+        return -EPIPE;
+    }
+
+    /* Check data for basic sanity */
+    if((count < sizeof(struct iphdr)) || (ip->version != 4)
+            || (count > 0xFFFF)) {
+        printk(KERN_INFO __FILE__ ": Packet so illegal, it's gonna be "
+                "ignored.\n");
+        return -EIO;
+    }
+
+    /* Get our device */
+    dev = ((struct proc_netwrite_entry*)data)->dev;
+    if(dev == NULL) {
+        printk(KERN_DEBUG __FILE__ ": Odd, lost the output device.\n");
+        return -EPIPE;
+    }
+
+    /* Make sure it's up */
+    if(!netif_running(dev)) {
+        printk(KERN_INFO __FILE__ ": Packet sent to down device %s\n",
+                dev->name);
+        return -EIO;
+    }
+
+    /* Create packet for sending */
+    skb = dev_alloc_skb(count);
+    if(skb == NULL) {
+        printk(KERN_INFO __FILE__ ": Out of memory, cannot create sk_buff\n");
+        return -ENOMEM;
+    }
+
+    /* Initialize data structure as necessary */
+    ip = (struct iphdr*)skb_put(skb, count);
+    memcpy(ip, buffer, count);
+
+    skb->h.raw = NULL;
+    skb->nh.iph = ip;
+    skb->mac.raw = NULL;
+
+    skb->pkt_type = PACKET_HOST;
+    skb->protocol = __constant_htons(ETH_P_IP);
+    skb->dev = dev;
+
+    skb->ip_summed = CHECKSUM_NONE;
+    skb->len = count;
+    do_gettimeofday(&skb->stamp);
+
+    /* "Receive" data */
+    printk(KERN_DEBUG __FILE__ ": Feeding a %ld byte packet into the stack\n",
+            count);
+    ip_rcv(skb, skb->dev, NULL);
+    return count;
+}
+
+/*
+ * List behavior
+ */
+
+/* Add an item to the list */
+static int proc_netwrite_addentry(struct net_device *dev) {
+    struct proc_netwrite_entry *newentry;
+    struct proc_dir_entry *newprocentry;
+
+    /* Attempt to create proc entry */
+    newprocentry = create_proc_entry(dev->name, S_IFREG|S_IRUGO|S_IWUSR,
+            proc_netwrite);
+    if(newprocentry == NULL) {
+        return 1;
+    }
+
+    /* Allocate memory for data structure */
+    newentry = kmalloc(sizeof(struct proc_netwrite_entry), GFP_ATOMIC);
+    if(newentry == NULL) {
+        remove_proc_entry(dev->name, proc_netwrite);
+        return 1;
+    }
+
+    /* Initialize */
+    newentry->next = NULL;
+    newentry->entry = newprocentry;
+    newentry->devname = dev->name;
+    newentry->dev = dev;
+    newprocentry->data = newentry;
+    newprocentry->write_proc = proc_netwrite_write;
+
+    /* Add to list */
+    if(proc_netwrite_entries == NULL) {
+        /* Empty list */
+        proc_netwrite_entries = newentry;
+    } else {
+        /* Find end of list and link in */
+        struct proc_netwrite_entry *head = proc_netwrite_entries;
+        for(; head->next; head = head->next);
+        head->next = newentry;
+    }
+
+    return 0;
+}
+
+/* Add all currently installed net devices to the list */
+static int proc_netwrite_addallentries() {
+    int err, errall = 0;
+    struct net_device *curr = dev_base;
+
+    while(curr) {
+        err = proc_netwrite_addentry(curr);
+        curr = curr->next;
+        if(err) {
+            errall = err;
+        }
+    }
+
+    return errall;
+}
+
+/* Remove from list */
+static int proc_netwrite_removeentry(struct net_device *dev) {
+    struct proc_netwrite_entry *prev, *curr;
+
+    /* Locate entry in list */
+    prev = NULL;
+    curr = proc_netwrite_entries;
+    while(curr && (curr->dev != dev)) {
+        prev = curr;
+        curr = curr->next;
+    }
+
+    /* If we found it, remove it */
+    if(curr) {
+        /* Remove from list */
+        if(prev) {
+            prev->next = curr->next;
+        } else {
+            proc_netwrite_entries = curr->next;
+        }
+        /* Remove proc entry */
+        curr->entry->data = NULL;
+        remove_proc_entry(curr->devname, proc_netwrite);
+        /* Clear it out in case proc file still open */
+        curr->dev = NULL;
+        curr->devname = NULL;
+        kfree(curr);
+    }
+
+    return 0;
+}
+
+/* Remove all entries in the list */
+static int proc_netwrite_removeallentries() {
+    while(proc_netwrite_entries != NULL) {
+        proc_netwrite_removeentry(proc_netwrite_entries->dev);
+    }
+
+    return 0;
+}
+
+/*
+ * Keep our /proc up to date with network devices
+ */
+int on_device_notify(struct notifier_block *self, unsigned long event, void *v) {
+    struct net_device *dev = (struct net_device*)v;
+    switch(event) {
+    case NETDEV_REGISTER:
+        /* New device added to kernel */
+        proc_netwrite_addentry(dev);
+        break;
+
+    case NETDEV_UNREGISTER:
+        /* Device being removed from kernel */
+        proc_netwrite_removeentry(dev);
+        break;
+    }
+    return NOTIFY_DONE;
+}
+
+struct notifier_block device_event_notifier = {
+    on_device_notify,
+    NULL,
+    0
+};
+
+/*
+ * Called when the module is inserted in the kernel.
+ */
+int init_module()
+{
+    /* Create directory to hold our nodes */
+    proc_netwrite = proc_mkdir("inject", proc_net);
+    if(proc_netwrite == NULL) {
+        /* Return failure if couldn't create the node */
+        return 1;
+    }
+    /* Create the nodes for currently installed devices */
+    proc_netwrite_addallentries();
+    /* Be notified on device changes */
+    register_netdevice_notifier(&device_event_notifier);
+    return 0;
+}
+
+/*
+ * Called when removing the module from memory... 
+ */
+void cleanup_module()
+{
+    /* Deregister entry into device notification */
+    unregister_netdevice_notifier(&device_event_notifier);
+    /* Remove existing devices */
+    proc_netwrite_removeallentries();
+    /* Remove node directory */
+    remove_proc_entry("inject", proc_net);
+}
+
+MODULE_DESCRIPTION("MAODV Gateway kernel support.");
+MODULE_AUTHOR("Jonathan McGee");
+#ifdef MODULE_LICENSE
+MODULE_LICENSE("GPL");
+#endif
diff -urNb aodv-uu-0.7.2/main.c maodv-umd-0.7.2/main.c
--- aodv-uu-0.7.2/main.c	Tue May 27 12:32:58 2003
+++ maodv-umd-0.7.2/main.c	Mon Jun 30 13:53:46 2003
@@ -43,6 +43,11 @@
 #include "aodv_hello.h"
 #include "packet_input.h"
 #include "packet_queue.h"
+#ifdef MAODV
+#include "multicast_routing_table.h"
+#include "multicast_packet_cache.h"
+#include "k_mroute.h"
+#endif
 
 #ifdef USE_IW_SPY
 #include "link_qual.h"
@@ -59,7 +64,7 @@
 int receive_n_hellos = 0;
 int hello_jittering = 1;
 int optimized_hellos = 0;
-int ratelimit = 1;		/* Option for rate limiting RREQs and RERRs. */
+int ratelimit = 0;		 /* Option for rate limiting RREQs and RERRs. */
 char *progname;
 int wait_on_reboot = 1;
 int hello_qual_threshold = 12;
@@ -191,36 +196,6 @@
     return 0;
 }
 
-int find_default_gw(void)
-{
-    FILE *route;
-    char buf[100], *l;
-
-    route = fopen("/proc/net/route", "r");
-
-    if (route == NULL) {
-	perror("open /proc/net/route");
-	exit(-1);
-    }
-
-    while (fgets(buf, sizeof(buf), route)) {
-	l = strtok(buf, " \t");
-	l = strtok(NULL, " \t");
-	if (l != NULL) {
-	    if (strcmp("00000000", l) == 0) {
-		l = strtok(NULL, " \t");
-		l = strtok(NULL, " \t");
-		if (strcmp("0003", l) == 0) {
-		    fclose(route);
-		    return 1;
-		}
-	    }
-	}
-    }
-    fclose(route);
-    return 0;
-}
-
 /*
  * Returns information on a network interface given its name...
  */
@@ -293,6 +268,17 @@
 	sprintf(buf, "/sbin/insmod kaodv.o ifname=%s &>/dev/null", ifname);
     system(buf);
 
+#ifdef MAODV
+	if(internet_gw_mode) {
+		memset(buf, '0', 64);
+		if(stat("./kinject.o", &st) < 0)
+		sprintf(buf, "/sbin/modprobe kinject &>/dev/null");
+		else
+		sprintf(buf, "/sbin/insmod kinject.o &>/dev/null");
+		system(buf);
+	}
+#endif
+
     /* Check result */
     m = fopen("/proc/modules", "r");
     while (fgets(buf, sizeof(buf), m)) {
@@ -318,6 +304,9 @@
 void remove_modules(void)
 {
     system("/sbin/modprobe -r kaodv &>/dev/null");
+#ifdef MAODV
+    system("/sbin/modprobe -r kinject &>/dev/null");
+#endif
     system("/sbin/modprobe -r ip_queue &>/dev/null");
 }
 
@@ -411,6 +400,12 @@
 
 	DEV_IFINDEX(ifreq.ifr_ifindex).ipaddr = ntohl(ina->sin_addr.s_addr);
 
+        #ifdef MAODV
+        /* CHECK */
+        kernel_mrt_vif_add( DEV_IFINDEX(ifreq.ifr_ifindex).ipaddr, 0 );
+
+        #endif
+
 	/* Get netmask of interface... */
 	ina = get_if_info(iface, SIOCGIFNETMASK);
 	if (ina == NULL)
@@ -426,6 +421,11 @@
 
 	DEV_IFINDEX(ifreq.ifr_ifindex).enabled = 1;
 
+#ifdef MAODV
+    /* No injection socket yet openned */
+	DEV_IFINDEX(ifreq.ifr_ifindex).injectfd = -1;
+#endif
+
 	if (this_host.nif >= MAX_NR_INTERFACES)
 	    break;
 
@@ -442,15 +442,19 @@
 	exit(-1);
     }
     if (internet_gw_mode) {
-	if (find_default_gw()) {
 	    log(LOG_NOTICE, 0, __FUNCTION__, "Internet gateway mode enabled!");
 	    this_host.gateway_mode = 1;
-	} else {
-	    this_host.gateway_mode = 0;
-	    sprintf(buf, "/sbin/route add default gw 127.0.0.1 dev lo");
-	    system(buf);
 	}
+
+#ifdef MAODV
+	/* Open up injection for interfaces when in gateway mode */
+	if(this_host.gateway_mode) {
+		for(i = 0; i < this_host.nif; i++) {
+			sprintf(buf, "/proc/net/inject/%s", this_host.devs[i].ifname);
+			this_host.devs[i].injectfd = open(buf, O_WRONLY);
     }
+    }
+#endif
 }
 
 /* This signal handler ensures clean exits */
@@ -594,8 +598,18 @@
     /* Initialize data structures and services... */
     rt_table_init();
     log_init();
-    packet_queue_init();
+#ifdef MAODV
+    if(!internet_gw_mode) {
+	    kernel_mrt_init();
+    }
+#endif
+
     host_init(ifname);
+#ifdef MAODV
+	mrt_table_init();
+	init_packet_cache();
+#endif
+    packet_queue_init();
     packet_input_init();
     aodv_socket_init();
 #ifdef USE_IW_SPY
@@ -665,11 +679,29 @@
 
 static void cleanup(void)
 {
+	int i;
+
     DEBUG(LOG_DEBUG, 0, "CLEANING UP!");
-    if (internet_gw_mode && !this_host.gateway_mode)
-	system("/sbin/route del default");
+
+#ifdef MAODV
+	/* Close the injection sockets prior to unloading kinject.o */
+	for(i = 0; i < this_host.nif; i++) {
+		if(this_host.devs[i].injectfd != -1) {
+			close(this_host.devs[i].injectfd);
+			this_host.devs[i].injectfd = -1;
+		}
+	}
+#endif
+
     remove_modules();
     rt_table_destroy();
+#ifdef MAODV
+    mrt_table_destroy();
+
+    /* CHECK: What interface? should we cycle through and fins a nice interface? */
+    kernel_mrt_vif_del( DEV_IFINDEX(0).ipaddr, 0 );
+    kernel_mrt_clean_up();
+#endif
     packet_input_cleanup();
     packet_queue_destroy();
     aodv_socket_cleanup();
